<?php

#------------------------------------------------------
# INFO
#------------------------------------------------------
# This is part of the Post Notification Plugin for 
# Wordpress. Please see the readme.txt for details.
#------------------------------------------------------


function post_notification_is_file($path, $file){
	if(!is_file($path . '/' . $file)){
		echo '<div class="error">'. __('File missing in profile folder.', 'post_notification') . '<br />';
		echo __('Folder', 'post_notification') . ': <b>' . $path . '</b><br />';
		echo __('File', 'post_notification') . ': <b>' . $file. '</b></div>';
		return false;
	}
	return true;
}

function post_notification_check_string($path, $string){
	include($path . '/strings.php');
	if(!array_key_exists($string, $post_notification_strings)){
		echo '<div class="error">'. __('Missing string in string file.', 'post_notification') .'<br />';
		echo __('File', 'post_notification') . ': <b>' . $path . '/strings.php </b><br />';
		echo __('String', 'post_notification') . ': <b>' . $string . '</b></div>';
		return false;
	}
	return true;
}

function post_notification_is_profile($path){
	if(!(
		post_notification_is_file($path , 'activated.tmpl') &&
		post_notification_is_file($path , 'confirm.tmpl') &&
		post_notification_is_file($path , 'reg_success.tmpl') &&
		post_notification_is_file($path , 'subscribe.tmpl') &&
		post_notification_is_file($path , 'subscribe.tmpl') &&
		post_notification_is_file($path , 'unsubscribe.tmpl') &&
		post_notification_is_file($path , 'strings.php'))) return false;
	
	if(!(
		post_notification_check_string($path, 'error') &&
		post_notification_check_string($path, 'already_subscribed') &&
		post_notification_check_string($path, 'activation_faild') &&
		post_notification_check_string($path, 'address_not_in_database') &&
		post_notification_check_string($path, 'sign_up_again') &&
		post_notification_check_string($path, 'deaktivated') &&
		post_notification_check_string($path, 'no_longer_activated') &&
		post_notification_check_string($path, 'check_email'))) return false;
	
	return true;

}


function post_notification_admin_sub(){
	echo  '<h3>' . __('Settings', 'post_notification') . '</h3>';

	if ($_POST['updateSettings']){
		
		
		
		//simple things first
		update_option('post_notification_read_more', $_POST['read_more']);
		update_option('post_notification_show_content', $_POST['show_content']);
		update_option('post_notification_send_default', $_POST['send_default']);
		update_option('post_notification_send_private', $_POST['send_private']);
		update_option('post_notification_send_page', $_POST['send_page']);
		update_option('post_notification_subject', $_POST['subject']);
		update_option('post_notification_from_name', $_POST['from_name']);
		update_option('post_notification_from_email', $_POST['from_email']);
		update_option('post_notification_page_name', $_POST['page_name']);
		update_option('post_notification_url', $_POST['pn_url']);
		
		if($_POST['uninstall'] == 'true')
			update_option('post_notification_uninstall', true);
		else
			update_option('post_notification_uninstall', false);
		
		
		$p_captcha = $_POST['captcha'];
		if(is_numeric($p_captcha)){
			if($p_captcha >= 0){
				update_option('post_notification_captcha', $p_captcha );
			} else {
				echo '<div class="error">' . __('Number of captcha-chars must be 0 or greater.', 'post_notification') . '</div>';
			}
		} else {
			echo '<div class="error">' . __('Number of captcha-chars must be a number.', 'post_notification') . '</div>';
		}
			
			
		
		$p_pause = $_POST['pause'];
		if(is_numeric($p_pause)){
			if($p_pause >= 0){
				update_option('post_notification_pause', $p_pause );
			} else {
				echo '<div class="error">' . __('Pause must be zero or greater.', 'post_notification') . '</div>';
			}
		} else {
			echo '<div class="error">' . __('Pause must be a number.', 'post_notification') . '</div>';
		}

		$p_nervous = $_POST['nervous'];
		if(is_numeric($p_nervous)){
			if($p_nervous >= 0){
				update_option('post_notification_nervous', $p_nervous);
			} else {
				echo '<div class="error">' . __('Nervous Finger must be zero or greater.', 'post_notification') . '</div>';
			}
		} else {
			echo '<div class="error">' . __('Nervous Finger must be a number.', 'post_notification') . '</div>';
		}


		
		$p_maxmail = $_POST['maxmails'];
		if(is_numeric($p_maxmail)){
			if($p_maxmail > 0){
				update_option('post_notification_maxsend', $p_maxmail );
			} else {
				echo '<div class="error">' . __('Number of mails must be greater then zero.', 'post_notification') .'</div>';
			}
		} else {
			echo '<div class="error">' . __('Number of mails must be a number', 'post_notification') . '</div>';
		}
		
		

		
		
		if($_POST['hdr_nl'] == "rn")
			update_option('post_notification_hdr_nl', "rn");
		else
			update_option('post_notification_hdr_nl', "n");
		
		
		
		// Check wheather the template exists in the Profile
		if(is_file(ABSPATH . 'wp-content/plugins/post_notification/' . $_POST['en_profile'] .'/' . $_POST['en_template'])){
			update_option('post_notification_profile', $_POST['en_profile']);
			update_option('post_notification_template', $_POST['en_template']);
		} else {
			// Don't save any Profile / Template-inforamtion so we don't get in to an inconsisten state;
			echo '<div class="error">' . __('Could not find the template in this profile. Please select a template and save again.', 'post_notification') . '</diV>';
			$profile = $_POST['en_profile'];
		}
		
		
		if($_POST['page_meta'] == 'add'){
			update_option('post_notification_page_meta', true);
		} else {
			update_option('post_notification_page_meta', false);
		}
			
		
		
		if($_POST['add_page']=="add"){
			$post_title = $_POST['page_name'];
			if(get_option('db_version')< 4772){
				$post_status = "static";
			} else {
				$post_type = "page";
				$post_status = "publish";
			}
			$post_data = compact(__('If you can read this, something went wrong. :-(', 'post_notification'),'post_title', 'post_status', 'post_type');
			$post_data = add_magic_quotes($post_data);
			$post_ID = wp_insert_post($post_data);
			add_post_meta($post_ID, '_wp_page_template',  'post_notification_template.php', true);
			update_option('post_notification_url', $post_ID);
		}
		echo '<H4>' . __('Data was updated.', 'post_notification') . '</H4>';
	} 
	
	
	$selected = 'selected="selected"';
	
	if(get_option('post_notification_hdr_nl') == 'rn')
		$hdr_rn = $selected;
	else
		$hdr_n = $selected;

	if(get_option('post_notification_show_content') == 'no')
		$contentN = $selected;
	else
		$contentY = $selected;
		
	if(get_option('post_notification_send_default') == 'no')
		$sendN = $selected;
	else
		$sendY = $selected;
		
	if(get_option('post_notification_send_private') == 'no')
		$privateN = $selected;
	else
		$privateY = $selected;
		
	if(get_option('post_notification_send_page') == 'no')
		$pageN = $selected;
	else
		$pageY = $selected;
		
		
	if(get_option('post_notification_page_meta'))
		$meta = 'checked = "checked"';
	
	
	if(get_option('post_notification_uninstall'))
		$uninstall = 'checked = "checked"';
	
	
	//Find Profiles
	if(!isset($profile)) //If the profile is already set, dont change.
		$profile = get_option('post_notification_profile');
		
	$dir_handle=opendir(ABSPATH . 'wp-content/plugins/post_notification/');
	while (false !== ($file = readdir ($dir_handle))) {
		if(is_dir(ABSPATH . 'wp-content/plugins/post_notification/' . $file) && $file[0] != '.' && $file[0] != '_') {
			if(post_notification_is_profile(ABSPATH . 'wp-content/plugins/post_notification/' . $file)){
				$en_profiles .= "<option value=\"$file\" ";
				if($file == $profile) $en_profiles .= ' selected="selected"';
				$en_profiles .= ">$file</option>";
			}
		}
	}
	closedir($dir_handle); 
	
	///Find templates
	$template = get_option('post_notification_template');
	$dir_handle=opendir(ABSPATH . 'wp-content/plugins/post_notification/' . $profile );
	while (false !== ($file = readdir ($dir_handle))) {
		if(substr($file, -5) == '.html' or substr($file, -4) == '.txt') {
			$en_templates .= "<option value=\"$file\" ";
			if($file == $template) $en_templates .= ' selected="selected"';
			$en_templates .= ">$file</option>";
		}
	}
	closedir($dir_handle); 

	?>
<form id="update" method="post" action="admin.php?page=post_notification/admin.php&amp;action=settings">
<table width="100%">
	
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Type of header line break:', 'post_notification'); ?></th>
	<td>
        <select name="hdr_nl" >
          <option value="rn" <?php  echo $hdr_rn; ?>>\r\n</option>
          <option value="n"  <?php  echo $hdr_n; ?>>\n</option>
        </select>	
	</td>
	</tr>
	<tr class="alternate">
		<td /> 
		<td>
			<?php _e('According to the PHP-specification \r\n must be used. Never the less quite a few servers have trouble if they get a \r\n instead of \n. You\'ll see part of the header in your mail if you have the wrong selection.', 'post_notification') ?>
		</td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Copy complete post in to the mail:', 'post_notification') ?></th>
		<td>
	        <select name="show_content" >
				<option value="no"      <?php  if(get_option('post_notification_show_content') == 'no') echo $selected; ?>><?php  _e('No', 'post_notification'); ?></option>
				<option value="yes"     <?php  if(get_option('post_notification_show_content') == 'yes') echo $selected; ?>><?php  _e('Yes', 'post_notification'); ?></option>
				<option value="more"    <?php  if(get_option('post_notification_show_content') == 'more') echo $selected; ?>><?php  _e('Up to the more-tag.', 'post_notification'); ?></option>
				<option value="excerpt"	<?php  if(get_option('post_notification_show_content') == 'excerpt') echo $selected; ?>><?php  _e('The excerpt', 'post_notification'); ?></option>
		</select>	
		</td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Read-more-text:', 'post_notification'); ?></th>
		<td><input name="read_more" type="text" size="35" value="<?php  echo get_option('post_notification_read_more'); ?>" /></td>
	</tr>
	<tr class="alternate">
		<td />
		<td><?php _e('This text is put behind the content in case the mail is truncated. E.g. because of the more-tag.', 'post_notification'); ?>
		</td>
	</tr>


	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Send normal posts by default:', 'post_notification'); ?></th>
		<td>
	        <select name="send_default" >
	          <option value="no"  <?php  echo $sendN; ?> > <?php  _e('No', 'post_notification'); ?></option>
	          <option value="yes" <?php  echo $sendY; ?> > <?php  _e('Yes', 'post_notification'); ?></option>
	        </select>	
		</td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Send private posts by default:', 'post_notification'); ?></th>
		<td><select name="send_private">
			<option value="no"  <?php  echo $privateN; ?>><?php  _e('No', 'post_notification'); ?></option>
			<option value="yes" <?php  echo $privateY; ?>><?php  _e('Yes', 'post_notification'); ?></option>
		</select></td>
	</tr>
	
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Send pages by default:', 'post_notification'); ?></th>
		<td>
			<select name="send_page">
				<option value="no"  <?php  echo $pageN; ?>><?php  _e('No', 'post_notification'); ?></option>
				<option value="yes" <?php  echo $pageY; ?>><?php  _e('Yes', 'post_notification'); ?></option>
			</select>
		</td>
	</tr>
	
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Profile:', 'post_notification'); ?></th>
		<td>
	        <select name="en_profile" >
				<?php  echo $en_profiles; ?>
	        </select>	
		</td>
	</tr>
	
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Template:', 'post_notification'); ?></th>
		<td>
	        <select name="en_template" >
				<?php  echo $en_templates; ?>
	        </select>	
		</td>
	</tr>
	<tr class="alternate">
		<td /> 
		<td>
			<?php _e('Templates with the extension .txt are sent as text-mails. Templates with the extension .html are sent as HTML-mails', 'post_notification'); ?>
		</td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Subject:', 'post_notification'); ?></th>
		<td><input name="subject" type="text" size="35" value="<?php  echo get_option('post_notification_subject'); ?>" /></td>
	</tr>
	<tr class="alternate">
		<td />
		<td><?php _e('Use @@blogname as placeholder for the blog name.', 'post_notification'); ?>
			<?php _e('Use @@title as placeholder for the title of the post.', 'post_notification'); ?>
		</td>
	</tr>
	
	
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Sender-Name:', 'post_notification'); ?></th>
		<td><input name="from_name" type="text" size="35" value="<?php  echo get_option('post_notification_from_name'); ?>" /></td>
	</tr>
	<tr class="alternate">
		<td />
		<td><?php _e('Use @@blogname as placeholder for the blog name.', 'post_notification'); ?>
		</td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Sender-Email:', 'post_notification'); ?></th>
		<td><input name="from_email" type="text"  size="35" value="<?php  echo get_option('post_notification_from_email'); ?>" /></td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Number of mails to be sent in a burst:', 'post_notification'); ?></th>
		<td><input name="maxmails" type="text" id="maxmail" size="35" value="<?php  echo get_option('post_notification_maxsend'); ?>" /></td>
	</tr>
	
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Pause between transmission.', 'post_notification'); ?></th>
		<td><input name="pause" type="text" id="pause" size="35" value="<?php  echo get_option('post_notification_pause'); ?>" /> <?php _e('seconds.', 'post_notification'); ?></td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Nervous finger wait', 'post_notification'); ?></th>
		<td>
	        <input name="nervous" type="text" id="nervous" size="35" value="<?php  echo get_option('post_notification_nervous'); ?>" />	<?php _e('seconds.', 'post_notification'); ?>
		</td>
	</tr>
	<tr class="alternate">
		<td /> 
		<td>
			<?php _e('This option sets the time to wait before sending an Email. So if you have an nervous finger you can unpublish your post quickly and no mails are sent.', 'post_notification'); ?>
		</td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;">
		<a href="<?php _e('http://en.wikipedia.org/wiki/Captcha', 'post_notification'); ?>"><?php _e('Captcha-chars', 'post_notification'); ?></a></th>
		<td><input name="captcha" type="text" size="60" value="<?php  echo get_option('post_notification_captcha'); ?>" /></td>
	</tr>
	<tr class="alternate">
		<td />
		<td> 
			<?php _e('Number of Captcha-chars. 0 is no Captcha', 'post_notification'); ?><br />
			<b><?php _e('Warning:', 'post_notification'); ?></b>
			<?php _e('Your template must support Captchas.', 'post_notification'); ?>
		</td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Name of the Post Notification page', 'post_notification'); ?></th>
		<td><input name="page_name" type="text" id="page_name" size="60" value="<?php echo get_option('post_notification_page_name'); ?>" /></td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Post Notification link in the meta-section', 'post_notification'); ?></th>
		<td><input name="page_meta" type="checkbox" id="page_meta" value="add" <?php echo $meta; ?> /></td>
	</tr>
	
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Add Post Notification page:', 'post_notification'); ?></th>
		<td><input name="add_page" type="checkbox" id="add_page" value="add" /></td>
	</tr>
	<tr class="alternate">
		<td />
		<td>
			<?php _e('Adds a Post Notification page to your pages.', 'post_notification');
				  _e('The file "post_notification_template.php" has been copied into the active theme. You may want to edit this file to fit your needs.  ', 'post_notification');?><br />
			<?php _e('This checkbox is cleared after execution.', 'post_notification');?>
		</td>
	</tr>
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Uninstall', 'post_notification') ?></th>
		<td><input name="uninstall" type="checkbox" id="uninstall" value="true" <?php echo $uninstall ?> /></td>
	</tr>
	<tr class="alternate">
		<td />
		<td>
			<?php _e('If this option is set, all database entries are deleted upon deactivation. Of course all data is lost.', 'post_notification'); ?>
		</td>
	</tr>
	
	
	<tr class="alternate">
		<th style="text-align:right;padding-right:10px;"><?php _e('Link to the Post Notification page.', 'post_notification'); ?></th>
		<td><input name="pn_url" type="text" id="pn_url" size="60" value="<?php  echo get_option('post_notification_url'); ?>" /></td>
	</tr>
	<tr class="alternate">
		<td />
		<td>
			<?php _e('This must be the URL or the ID of the page on which you subscribe.', 'post_notification'); ?>
		</td>
	</tr>
	
	
	<tr class="alternate">
	<td>&nbsp;</td>
	<td><input type="submit" name="updateSettings" value="<?php _e('save', 'post_notification'); ?>" /></td>
	</tr>
</table>		
</form>	
<?php
}
?> 
